$.level = 2;

const mm = 72/25.4


  markWeight = 0.25
  markLength = 5 *mm
  markOffset = 0 *mm

offsetStr = "Offset trim marx, bleed, color (c,m,y,k,r(registration))";
distribStr = "Distibute object?";
var regColor = new CMYKColor();
regColor.cyan = 100;
regColor.magenta = 0;
regColor.yellow = 0;
regColor.black = 0;

if ( documents.length > 0 )
{
	doc = app.activeDocument;
	var bnd = new Array();
	origin = doc.rulerOrigin;
	var start = true;

	if(of = prompt(offsetStr, "0 2 c")) {
			param = of.split(' ');
			bleedOffset = param[1] *mm 			
			markOffset = param[0] *mm;
			param[1] *= mm;
			if (param[2]=='c'){
				regColor.cyan = 100;
				regColor.magenta = 0;
				regColor.yellow = 0;
				regColor.black = 0;
			}
			if (param[2]=='m'){
				regColor.cyan = 0;
				regColor.magenta = 100;
				regColor.yellow = 0;
				regColor.black = 0;
			}
			if (param[2]=='y'){
				regColor.cyan = 0;
				regColor.magenta = 0;
				regColor.yellow = 100;
				regColor.black = 0;
			}
			if (param[2]=='k'){
				regColor.cyan = 0;
				regColor.magenta = 0;
				regColor.yellow = 0;
				regColor.black = 100;
			}
			if (param[2]=='r'){
				var regColor = new SpotColor();
				regColor.spot = doc.spots['[Registration]'];
			}
			var obj = doc.selection;
			var mLayer= doc.layers.add();
			mLayer.name = 'MarX';
		}
		else start = false;
	if (start){
	if(doc.selection instanceof Array && doc.selection.length==1) {										
		bnd = getBounds(obj);
		x1 = bnd[0];
		x2 = bnd[2];
		y1 = bnd[1];
		y2 = bnd[3];
		W = x2-x1;
		H = y1-y2;
		xN = Math.floor(doc.width/W);
		yN = Math.floor(doc.height/H);
		if(confirm(distribStr)) {
			var dx = 0;
			var dy = 0;
			if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ){
				ox = ((doc.width-(W*xN))/2)-origin[0]+(obj[0].pathItems[0].left - x1);
				oy = ((doc.height-(H*yN))/2)-origin[1]+(obj[0].pathItems[0].top - y1);
				dx = obj[0].left - x1;
				dy = obj[0].top - y1;				
			}
			else {
				ox = ((doc.width-(W*xN))/2)-origin[0]+(obj[0].left - x1);
				oy = ((doc.height-(H*yN))/2)-origin[1]+(obj[0].top - y1);
			}			
			for(i=0; i<xN; i++) 
			for(j=1; j<=yN; j++) {
				objCopy = obj[0].duplicate(obj[0].parent);
				objCopy.left = ox+i*W+dx;
				objCopy.top = oy+j*H+dy;
				TrimMarX (mLayer,ox+i*W,oy+j*H,ox+i*W+W,oy+j*H-H,regColor,markWeight,markOffset,bleedOffset);
			}
			obj[0].remove();
			mLayer.zOrder(ZOrderMethod.SENDTOBACK);
		}
		else {
			mLayer.zOrder(ZOrderMethod.SENDTOBACK);
			TrimMarX (mLayer,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset);
		}
	}
	else { 
		for(i=0; i<obj.length; i++){
			if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) bnd = obj[i].pathItems[0].geometricBounds;
			else bnd = obj[i].geometricBounds;
			x1 = bnd[0];
			x2 = bnd[2];
			y1 = bnd[1];
			y2 = bnd[3];
			TrimMarX (mLayer,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset);
		}
		mLayer.zOrder(ZOrderMethod.SENDTOBACK);
	}
	}
}
function line(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function getBounds(obj) {	
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ) vgb1 = obj[0].pathItems[0].geometricBounds;
		else vgb1 = obj[0].geometricBounds;
		if (n > 1) {
			for (i=1; i<n; i++) {				
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = obj[i].geometricBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}

function TrimMarX (mLayer,x1,y1,x2,y2,regColor,markWeight,markOffset,bleedOffset){
	line(mLayer,x1+bleedOffset,y1+markOffset,x1+bleedOffset,y1+markOffset+markLength,regColor,markWeight);
	line(mLayer,x2-bleedOffset,y1+markOffset,x2-bleedOffset,y1+markOffset+markLength,regColor,markWeight);
	line(mLayer,x1+bleedOffset,y2-markOffset,x1+bleedOffset,y2-markOffset-markLength,regColor,markWeight);
	line(mLayer,x2-bleedOffset,y2-markOffset,x2-bleedOffset,y2-markOffset-markLength,regColor,markWeight);
	line(mLayer,x1-markOffset-markLength,y1-bleedOffset,x1-markOffset,y1-bleedOffset,regColor,markWeight);
	line(mLayer,x2+markOffset+markLength,y1-bleedOffset,x2+markOffset,y1-bleedOffset,regColor,markWeight);
	line(mLayer,x1-markOffset-markLength,y2+bleedOffset,x1-markOffset,y2+bleedOffset,regColor,markWeight);
	line(mLayer,x2+markOffset+markLength,y2+bleedOffset,x2+markOffset,y2+bleedOffset,regColor,markWeight);
}

